Attribute VB_Name = "RButton"
Option Explicit

Public ArSize As Integer        ' 
Public ArHWND() As Long         '  
Public ArProcOld() As Long      '   
Public ArTrack() As Boolean     '  

Public ArReference() As Control ' ...


Type TrackMouseEvent
  cbSize As Long
  dwFlags As Long
  hwndTrack As Long
  dwHoverTime As Long
End Type
' dwFlags:
Const TME_HOVER = &H1
Const TME_LEAVE As Long = &H2
Const TME_QUERY = &H40000000
Const TME_CANCEL = &H80000000
Const HOVER_DEFAULT = &HFFFFFFFF 'dwHoverTime

'API Calls:
Private Declare Function TrackMouseEvent Lib "user32.dll" _
    (TME As TrackMouseEvent) As Long
' return 0 on error
'Posted messages:
 Const WM_MOUSEHOVER = &H2A1
 Const WM_MOUSELEAVE As Integer = &H2A3
 Const WM_MOUSEMOVE = &H200
 Const WM_EXITMENULOOP = &H212
 
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" _
(ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, _
    ByVal wParam As Long, ByVal lParam As Long) As Long

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
    
    
Public Function StartTracking(h As Long) As Long
Dim tme1 As TrackMouseEvent
        tme1.cbSize = Len(tme1)
        tme1.dwFlags = TME_LEAVE '<<<<<<<<
        tme1.dwHoverTime = HOVER_DEFAULT
        tme1.hwndTrack = h
    StartTracking = TrackMouseEvent(tme1)
End Function

Public Function SubClassUC(ByVal hwnd As Long, ByVal iMsg As Long, _
                            ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim r As Long
    Dim i As Long
    ' 1 -       - i
    For i = 0 To ArSize - 1
        If ArHWND(i) = hwnd Then Exit For
    Next i
    ' 2 -  
    If iMsg = WM_MOUSEMOVE Then
            If ArTrack(i) = False Then
                r = StartTracking(hwnd): ArTrack(i) = True
            End If
    ElseIf iMsg = WM_MOUSELEAVE Then
            'notify control...
            lParam = &HFFFFFFFF
            ArTrack(i) = False  ' 
            iMsg = WM_MOUSEMOVE '  MOUSEMOVE
    End If
    If iMsg = WM_EXITMENULOOP Then ArReference(i).BackColor = vbBlue ' <- !!!
    '       
    SubClassUC = CallWindowProc(ByVal ArProcOld(i), ByVal hwnd, ByVal iMsg, ByVal wParam, ByVal lParam)
End Function




