VERSION 5.00
Begin VB.UserControl RBut 
   AutoRedraw      =   -1  'True
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
End
Attribute VB_Name = "RBut"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Const GWL_WNDPROC = (-4)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseLeave()
Dim ProcOld As Long
Dim SubClassEnabled As Boolean
Dim TrFa As Boolean
Const MERGECOPY = &HC000CA       ' (DWORD) dest = (source AND pattern)
Const MERGEPAINT = &HBB0226      ' (DWORD) dest = (NOT source) OR dest
Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Const SRCERASE = &H440328        ' (DWORD) dest = source AND (NOT dest )
Const SRCINVERT = &H660046       ' (DWORD) dest = source XOR dest
Const SRCPAINT = &HEE0086        ' (DWORD) dest = source OR dest
Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Private Const SND_ASYNC = &H1         '  play asynchronously
Private Const SND_FILENAME = &H20000     '  name is a file name
Private Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function RoundRect Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
'Default Property Values:
Const m_def_Color = &HE0E0E0
Const m_def_Caption = "RBut"
Const m_def_ForeColor = vbBlack
Const m_def_BackColor = &HC0C0C0
Const m_def_Enabled = True
'Property Variables:
Dim m_Color As OLE_COLOR
Dim m_Caption As String
Dim m_ForeColor As OLE_COLOR
Dim m_BackColor As OLE_COLOR
Dim m_Enabled As Boolean
Dim m_Font As Font
'Event Declarations:
Event Click()
Event DblClick()
Event KeyDown(KeyCode As Integer, Shift As Integer)
Event KeyPress(KeyAscii As Integer)
Event KeyUp(KeyCode As Integer, Shift As Integer)
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,vbCyan
Public Property Get BackColor() As OLE_COLOR
    BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_BackColor = New_BackColor
    PropertyChanged "BackColor"
    Update
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,True0
Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    PropertyChanged "Enabled"
    Update
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=6,0,0,0
Public Property Get Font() As Font
    Set Font = m_Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set m_Font = New_Font
    PropertyChanged "Font"
    UserControl.Font = m_Font
End Property

Private Sub UserControl_Click()
'*********'
sndPlaySound "C:\windows\media\start.wav", SND_FILENAME Or SND_ASYNC
UserControl.BackColor = m_Color
UserControl.FontSize = 8
UserControl.CurrentX = (ScaleWidth - TextWidth(m_Caption)) / 2
UserControl.CurrentY = (ScaleHeight - TextHeight(m_Caption)) / 2
Refresh
Rectangle UserControl.hdc, 0, 0, UserControl.Width / 15, UserControl.Height / 15
Print m_Caption
RaiseEvent Click
'*******'
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_BackColor = m_def_BackColor
    m_Enabled = m_def_Enabled
    Set m_Font = Ambient.Font
    m_ForeColor = m_def_ForeColor
    m_Caption = m_def_Caption
    m_Color = m_def_Color
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If X < 0 Then
        ' MouseLeave
        RaiseEvent MouseLeave
        Update
        Exit Sub
    End If
    RaiseEvent MouseMove(Button, Shift, X, Y)

End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    Set m_Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    m_Color = PropBag.ReadProperty("Color", m_def_Color)
    
    If Ambient.UserMode Then                                      ' <- !!!
    ProcOld = SetWindowLong(UserControl.hwnd, GWL_WNDPROC, AddressOf SubClassUC)
    If ProcOld = 0 Then SubClassEnabled = False: Exit Sub
    SubClassEnabled = True
    If ArSize = 0 Then
        ReDim ArHWND(0)
        ReDim ArProcOld(0)
        ReDim ArTrack(0)
        ReDim ArReference(0)                                    ' <- !!!
    End If
    ArHWND(ArSize) = UserControl.hwnd
    ArProcOld(ArSize) = ProcOld
    Set ArReference(ArSize) = Parent.Controls(Extender.Name)    ' <- !!!
    
    ArSize = ArSize + 1
    ReDim Preserve ArHWND(ArSize)
    ReDim Preserve ArProcOld(ArSize)
    ReDim Preserve ArTrack(ArSize)
    ReDim Preserve ArReference(ArSize)                          ' <- !!!
    UserControl.AutoRedraw = True
  End If
End Sub
Private Sub UserControl_Resize()
Dim Rgn As Long
With UserControl
    On Error GoTo Err:
    If .Height > 1000 Then .Height = 1000
    If .Height < 260 Then .Height = 260
    If .Width > 1500 Then .Width = 1500
    If .Width < 320 Then .Width = 320
    Rgn = CreateRectRgn(0, 0, .Width / 15, .Height / 15)
    SetWindowRgn .hwnd, Rgn, True
Err:
End With
Update
End Sub

Private Sub UserControl_Show()
    Update
End Sub

Private Sub UserControl_Terminate()
    ArSize = 0
    If SubClassEnabled = False Then Exit Sub
    '       
    Call SetWindowLong(UserControl.hwnd, GWL_WNDPROC, ProcOld)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BackColor", m_BackColor, m_def_BackColor)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("Font", m_Font, Ambient.Font)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("Color", m_Color, m_def_Color)
End Sub

Sub Update()
With UserControl
    Cls
    .BackColor = m_BackColor
    .ForeColor = m_ForeColor
    .Enabled = m_Enabled
    .FontSize = 8
    .CurrentX = (ScaleWidth - TextWidth(m_Caption)) / 2
    .CurrentY = (ScaleHeight - TextHeight(m_Caption)) / 2
    Refresh
    Rectangle .hdc, 0, 0, .Width / 15, .Height / 15
    Print m_Caption
End With
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,vbBlack
Public Property Get ForeColor() As OLE_COLOR
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
End Property


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,RBut
Public Property Get Caption() As String
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"
    UserControl.FontSize = 8
    UserControl.CurrentX = (ScaleWidth - TextWidth(m_Caption)) / 2
    UserControl.CurrentY = (ScaleHeight - TextHeight(m_Caption)) / 2
    UserControl.Print m_Caption
    Update
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=10,0,0,vbBlue
Public Property Get Color() As OLE_COLOR
    Color = m_Color
End Property

Public Property Let Color(ByVal New_Color As OLE_COLOR)
    m_Color = New_Color
    PropertyChanged "Color"
    Update
End Property
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=5

